'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
' Demonstration program for MMB4W. MM.VPos -> MM.HRes and MMHpos  '                       '
' It does not do anything useful except demo the various controls '
' Geoff Graham, October 2015                                      '
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Option Explicit
Dim ledsY
Colour RGB(white), RGB(black)
' Reference numbers for the controls are defined as constants.
Const c_head = 1, c_pmp = 2, sw_pmp = 3, c_flow = 4, tb_flow = 5
Const led_run = 6, led_alarm = 7
Const frm_alarm = 20, nbr_hi = 21, nbr_lo = 22, pb_test =23
Const c_hi = 24, c_lo = 25
Const frm_pump = 30, r_econ = 31, r_norm = 32, r_hi = 33
Const frm_log = 40, cb_enabled = 41, c_fname = 42, tb_fname = 43
Const c_log = 44, cb_flow = 45, cb_pwr = 46, cb_warn = 47
Const cb_alarm = 48, c_bright = 49, sb_bright = 50
' Now draw the "Pump Control" display.
CLS
GUI Interrupt TouchDown, TouchUp
' Display the heading.
Font 2,2 : GUI Caption c_head, "Beregenings Pomp", 10, 0
Font 3 : GUI Caption c_pmp, "Pomp", 20, 60, , RGB(brown)
' Now, define and display the controls.
' First display the switch.
Font 4
GUI Switch sw_pmp, "AAN|UIT", 20, 90, 150, 50, RGB(white),RGB(brown)
CtrlVal(sw_pmp) = 1
' The flow rate display box.
Font 3 : GUI Caption c_flow, "Flow Waarde", 20, 170,, RGB(brown), 0
Font 4 : GUI Displaybox tb_flow, 20, 200, 150, 45
CtrlVal(tb_flow) = "20.1"
' The radio buttons and their frame.
Font 3 : GUI Frame frm_pump, "Starten", 20, 290, 170, 163, RGB(200, 20, 255)
GUI Radio r_econ, "Laag", 43, 328, 12, RGB(230, 230, 255)
GUI Radio r_norm, "Normaal", 43, 374
GUI Radio r_hi, "Hoog", 43, 418
CtrlVal(r_norm) = 1          ' Start with the "normal" button selected.
' The alarm frame with two number boxes and a push button switch.
Font 3 : GUI Frame frm_alarm, "Alarm", 220, 220, 200, 233,RGB(green)
GUI Caption c_hi, "Hoog:", 232, 260, "LT", RGB(yellow)
GUI Numberbox nbr_hi, 318,MM.Vres/1.5-6,90,MM.FontHeight+12,RGB(yellow),RGB(64,64,64)
GUI Caption c_lo, "Laag:", 232, 325, LT, RGB(yellow),0
GUI Numberbox nbr_lo, 318,MM.Vres/1.5-6,90,MM.FontHeight+12,RGB(yellow),RGB(64,64,64)
GUI Button pb_test, "ALARM", 257, 383, 130, 40,RGB(yellow), RGB(red)
CtrlVal(nbr_lo) = 15.7 : CtrlVal(nbr_hi) = 35.5
' Draw the two LEDs.
Const ledsX = 255, coff = 50 ' Define their position.
ledsY = 105 : GUI LED led_run, "Draaien", ledsX, ledsY, 15, RGB(green)
ledsY = ledsY+49 : GUI LED led_alarm, "Alarm", ledsX, ledsY, 15, RGB(red)
CtrlVal(led_run) = 1         ' The switch defaults to on so set the LED on.
' The logging frame with check boxes and a text box.
Colour RGB(cyan), 0
GUI Frame frm_log, "Log File", 450, 20, 330, 355, RGB(green)
GUI Checkbox cb_enabled, "Loggen Starten", 470, 50, 30, RGB(cyan)
GUI Caption c_fname, "File Naam", 470, 105
GUI Textbox tb_fname, 470, 135, 290, 40, RGB(cyan), RGB(64,64,64)
GUI Caption c_log, "Opnemen:", 470, 205, , RGB(cyan), 0
GUI Checkbox cb_flow, "Flow Waarde", 500, 245, 25
GUI Checkbox cb_alarm, "Alarmen", 500, 285, 25
GUI Checkbox cb_warn, "Oppassen", 500, 325, 25
CtrlVal(cb_enabled) = 1
CtrlVal(tb_fname) = "LOGFILE.TXT"
' Define and display the spinbox for controlling the backlight.
GUI Caption c_bright, "Helderheid", 442, 415, ,RGB(200,200,255),0
GUI Spinbox sb_bright, MM.Hres/1.7 + 8, 400, 200, 50,,,10, 10, 100
CtrlVal(sb_bright) = 100
' All the controls have been defined and displayed. At this point
' the program could do some real work but because this is just a
' demo there is nothing to do. So it just sits in a loop.
Do : Loop
' The interrupt routine for touch down using a select case command 
' it has a different process for each control.
Sub TouchDown
Select Case Touch(REF)       ' Find out the control touched.
Case cb_enabled              ' The enable check box.
If CtrlVal(cb_enabled) Then
GUI Enable c_fname, tb_fname, c_log, cb_flow, cb_alarm, cb_warn
Else
GUI Disable c_fname, tb_fname, c_log, cb_flow, cb_alarm, cb_warn
EndIf
Case sb_bright               ' The brightness spin box.
' BackLight CtrlVal(sb_bright).
Case sw_pmp                  ' The pump on/off switch.
CtrlVal(led_run) = CtrlVal(sw_pmp)
CtrlVal(tb_flow) = Str$(CtrlVal(sw_pmp) * 20.1)
CtrlVal(r_norm)  = 1
Case pb_test                 ' The alarm test button.
CtrlVal(led_alarm) = 1
GUI Beep 250
Case r_econ                  ' The economy radio button.
CtrlVal(tb_flow) = Str$(CtrlVal(sw_pmp) * 18.3)
Case r_norm                  ' The normal radio button.
CtrlVal(tb_flow) = Str$(CtrlVal(sw_pmp) * 20.1)
Case r_hi                    ' The high radio button.
CtrlVal(tb_flow) = Str$(CtrlVal(sw_pmp) * 23.7)
End Select
End Sub
' Interrupt routine when the touch is removed.
Sub TouchUp
Select Case Touch(LASTREF)   ' Use the last reference.
Case pb_test                 ' Was it the test button.
CtrlVal(led_alarm) = 0       ' Turn off the LED.
End Select
End Sub
